// Vg[x֐̌vZvOxbZ֐̌vZvOɍ쐬̂
// f̌vZƂȂĂ܂B
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart, System.Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    Series5: TLineSeries;
    Series6: TLineSeries;
    CheckBox2: TCheckBox;
    LabeledEdit3: TLabeledEdit;
    CheckBox3: TCheckBox;
    NonComplex: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure NonComplexClick(Sender: TObject);
  private
    { Private 錾 }
    procedure chart1coment;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses system.Math, Velthuis.BigIntegers,mp_real, mp_cmplx, mp_types, mp_base;

{$R *.dfm}

type
  DArray = array of double;

var
  BM : array of mp_float;       // xk[Cz
  FA : array of mp_float;       // (k+3/2)z
  PVG : array of mp_float;      // +V

  zero, one, two, four : mp_float;
  three, pai, log_2pis2 : mp_float;
  oneahf : mp_float;

const
  KMmax = 250;                  // KM max   250
  Vmax  = 100;                  // v  max

//------------------------------------------------------------------------------
  NB = 120;                            // xk[C  z NB + 1

var
  NumeratorString : array[0..NB] of string;               // q
  DenominatorString  : array[0..NB] of string;            // 

// ő  [Nbȟݏ@ BigInteger
function gcd_BigInteger(x, y: BigInteger): BigInteger;
var
  t : BigInteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[C
// Akiyama-Tanigawa algorithm
// BigInteger
procedure Bernoulli_number_BigInteger;
const
  n = (NB + 1) * 2;
var
  m, j, k : integer;
  a     : array of BigInteger;      // q
  b     : array of BigInteger;      // 
  tmpN  : BigInteger;               // q
  tmpD  : BigInteger;               // 
  gcd   : BigInteger;               // ő
  b0    : BigInteger;
begin
  setlength(a, n + 1);
  setlength(b, n + 1);
  k := 0;
  for m := 0 to n do begin
    a[m] := 1;                         // q l
    b[m] := (m + 1);                                //  l
    for j := m - 1 downto 0 do begin
      tmpN := a[j] * b[j + 1] - a[j + 1] * b[j];    // q
      tmpN := tmpN * (j + 1);                       // V
      tmpD := b[j] * b[j + 1];                      // 
      gcd := gcd_BigInteger(tmpN, tmpD);            // ő
      a[j] := tmpN div gcd;
      b[j] := tmpD div gcd;
    end;
    if (m > 0) and (m mod 2 = 0) then begin
      b0 := b[0];
      b0 := b0 * m * (m -1);                       // m xk[CNo
      NumeratorString[k] := a[0].tostring;
      DenominatorString[k] := b0.tostring;
      inc(k);
    end;
  end;
end;

//------------------------------------------------------------------------------

// OK}{
procedure log_GammaMul(var x, ans : mp_float);
var
  v, w : mp_float;
  tmp, tmp0, s : mp_float;
  i : integer;
begin
  mpf_init2(v, w);
  mpf_init3(tmp, tmp0, s);

  mpf_set1(v);
  mpf_set_int(tmp, NB);
  while mpf_is_lt(x, tmp) do begin
    mpf_mul(v, x, v);
    mpf_add(x, one, x);
  end;
  mpf_mul(x, x, tmp);               // x^2
  mpf_div(one, tmp, w);             // w = 1 / x^2
  mpf_set0(s);
  for i := NB downto 1 do begin
    mpf_add(s, BM[i], tmp);         // tmp = s + B[i]
    mpf_mul(tmp, w, s);             // s = tmp * w
  end;
  mpf_add(s, BM[0], tmp);           // tmp = s + B[0]
  mpf_div(tmp, x, s);               // s = (s + B[0]) / x
  mpf_add(s, log_2pis2, s);         // s = s + ln(2)/2
  mpf_ln(v, tmp);                   // ln(v)
  mpf_sub(s, tmp, s);               // s := s - ln(v)
  mpf_sub(s, x, s);                 // s := s - x
  mpf_div(one, two, tmp);           // tmp = 1/2
  mpf_sub(x, tmp, tmp0);            // tmp0 = x - 1/2
  mpf_ln(x, tmp);                   // ln(x)
  mpf_mul(tmp0, tmp, tmp0);         // tmp0 = (x - 1/2) * ln(x)
  mpf_add(s, tmp0, ans);            // ans = s + (x - 1/2) * ln(x)

  mpf_clear2(v, w);
  mpf_clear3(tmp, tmp0, s);
end;

// {K}
// x̒l 0 ƕ̎́ɂȂ̂łĂ܂̂ŃG[ɂȂ܂B
// Pr͎̎̎gp܂B
procedure gammaMul(var x, ans: mp_float);
var
  tmp, tmp0, logG : mp_float;
begin
  mpf_init3(tmp, tmp0, logG);

  if mpf_is_lt(x, zero) then begin
    mpf_mul(pai, x, tmp);            // x*
    mpf_sin(tmp, tmp0);              // sin(x);
    mpf_sub(one, x, tmp);            // 1-x
    log_GammaMul(tmp, logG);         // loggamma(1-x);
    mpf_exp(logG, logG);             // exp(logG)
    mpf_div(pai, tmp0, tmp);         // /sin(x)
    mpf_div(tmp, logG, ans);         // ans = /(sin(x) * logG(1-x))
  end
  else begin
    log_GammaMul(x, logG);           // logG
    mpf_exp(logG, ans);              // exp(logG)
  end;

  mpf_clear3(tmp, tmp0, logG);
end;


//------------------------------- complex power --------------------------------
// mpc_pow**.5Ԃ܂
// {[ɂȂ鏊Ƀ[Ŗl܂
// x(-0.5, 0)   y(1.5, 0) L70O
// x(-0.5, -0.5) y(4, 0)  L60O
// x(-0.5, 0.5)  y(2, 0) L70O
procedure mpc_powa(x, y : mp_complex; var ans : mp_complex);
var
  ay, ai, zero, harf, two : mp_float;
begin
  mpf_init5(ay, ai, zero, harf, two);

  mpf_set_int(two, 2);                  // 2
  mpc_pow(x, y, ans);                     // exp(y*ln(x))
  // x̋y̋0Ȃ
  if mpf_is0(x.im) and mpf_is0(y.im) then begin
    mpf_set0(zero);                       // 0
    mpf_inv(two, harf);                   // 1/2  0.5
    mpf_abs(y.re, ay);                    // y̎̐Βl
    mpf_frac(ay, ai);                     // y̎̐Βl̏
    mpf_sub(ai, harf, ai);                // y̎̐Βl̏0.5̍
    // [(y̎̏0.5)
    if mpf_is0(ai) then
      // x̎0Ɠ0傫Ȃ
      if mpf_is_ge(x.re, zero) then mpf_set0(ans.im)   // ̋0
                               // 0菬Ȃ
                               else mpf_set0(ans.re);  // ̎0
    mpf_frac(y.re, ai);                                // 搔̏
    if mpf_is0(ai) then mpf_set0(ans.im);              // Ȃ瓚̋0
  end;
  // x̐y̋0Ȃ
  if mpf_is0(x.re) and mpf_is0(y.im) then begin
    mpf_frac(y.re, ai);                                // 搔̏
    if mpf_is0(ai) then begin                          // Ȃ
      mpf_div(y.re, two, ay);                          // mF
      mpf_frac(ay, ai);                                // 
      if mpf_is0(ai) then mpf_set0(ans.im)             // Ȃ 0
                     else mpf_set0(ans.re)             // Ȃ0
    end;
  end;
  mpf_abs(x.re, ay);
  mpf_abs(x.im, ai);
  // x̎Ƌ̐Βly[łȂ
  if mpf_is_eq(ay, ai) and mpf_is0(y.im) and not mpc_is0(y) then begin
    mpf_frac(y.re, ai);                                // 搔̏
    if mpf_is0(ai) then begin                          // Ȃ
      mpf_div(y.re, two, ay);                          // mF
      mpf_frac(ay, ai);                                // 
      if mpf_is0(ai) then begin
        mpf_add(two, two, two);                        // 4
        mpf_div(y.re, two, ay);                        // 4mF
        mpf_frac(ay, ai);                              // 
        if mpf_is0(ai) then mpf_set0(ans.im)           // Ȃ 0
                       else mpf_set0(ans.re);          // Ȃ 0
      end;
    end;
  end;

  mpf_clear5(ay, ai, zero, harf, two);
end;

//------------------------------------------------------------------------------
// Hv(x) Lhv {
// X l f
// v 
procedure Hvx(v : mp_float; var x, ri: mp_complex);
var
  k : integer;
  s, x24k, tmp, tmp0, tmp1 : mp_complex;
  xc, xs2: mp_complex;
  kd, nd, vk : mp_float;
  khg, kf : mp_float;
  tmf, tmf0 : mp_float;
  sb : mp_complex;
begin
  mpc_init5(s, x24k, tmp, tmp0, tmp1);
  mpc_init2(xc, xs2);
  mpf_init2(khg, kf);
  mpf_init3(kd, nd, vk);
  mpf_init2(tmf, tmf0);
  mpc_init(sb);

  mpc_set0(s);                              // =0
  mpc_set0(sb);
  mpc_set1(x24k);                           // k=0 ((x^2)/4)^0 l

  mpc_div_mpf(x, two, xs2);                 // x / 2

  mpc_mul(xs2, xs2, xc);                    // (x^2)/ 4

  for k := 0 to KMmax do begin
    mpf_set1(nd);
    mpf_add_int(v, k, tmf0);                // k + v
    mpf_add(tmf0, oneahf, vk);              // vk = k + v + 3/2;
    if mpf_is_lt(vk, zero) then begin       // vk < 0  nxmF
      mpf_int(vk, tmf);                     // int(vk);
      mpf_sub(vk, tmf, nd);                 // vk - int(vk) vk̐ vk = 0
    end;
    if mpf_is_ne(vk, zero) and mpf_is_ne(nd, zero) then begin  // vk̐̎͌vZȂ
      mpf_mul(FA[k], PVG[k], khg);          // (k+3/2)(v+k+3/2) vk0,̐̎}
      mpc_div_mpf(x24k, khg, tmp0);         // ((i(x^2)/4)^k)/((k+3/2)(v+k+3/2))
      if Form1.CheckBox3.Checked = false then       // true  Lvx
        if k mod 2 <> 0 then mpc_chs(tmp0, tmp0);   // false Hvx (-1)^k
      mpc_add(s, tmp0, s);                  // 
      mpc_sub(s, sb, tmp0);
      if mpc_is0(tmp0) then break;
      mpc_copy(s, sb);
    end;
    mpc_mul(x24k, xc, x24k);                // (i(x^2)/4)^k
  end;
  mpf_add(v, one, tmf0);                    // V+1
  mpc_set_mpf(tmp, tmf0, zero);             // (v+1)+ 0i
  // x 0Ŏv̎powerZ[ł̏Zh~
  if mpc_is0(x) and mpf_is_lt(tmf0, zero) then // (V+1)<0 x=0 ͖ɂȂ̂ŌvZȂ
  else begin
    mpc_powa(xs2, tmp, tmp0);               // (x/2)^(v+1)
    mpc_mul(s, tmp0, s);                    // (x/2)^(v+1) * 
  end;
  mpc_copy(s, ri);

  mpc_clear5(s, x24k, tmp, tmp0, tmp1);
  mpc_clear2(xc, xs2);
  mpf_clear2(khg, kf);
  mpf_clear3(kd, nd, vk);
  mpf_clear2(tmf, tmf0);
  mpc_clear(sb);
end;

// OtobNOEh
procedure ChartBackclear;
begin
  with Form1.Chart1.BackImage.Bitmap.Canvas do begin
    Brush.Color := clBtnFace;
    Brush.Style := bsSolid;
    FillRect(rect(0, 0, Form1.Chart1.Width, Form1.Chart1.Height));
    Brush.Style := bsClear;
  end;
end;

// OtobNOEh@C̎ޕ\
procedure TForm1.chart1coment;
begin
  with Chart1.BackImage.Bitmap.Canvas do begin
    Font.Size := 8;
    Font.Style := [];
    Font.Color := clred;
    TextOut(chart1.Width - 30, 1,'');
    Font.Color := clblue;
    if NonComplex.Checked = false then
      TextOut(chart1.Width - 30, 13,'');
    Pen.Width := 1;
    Pen.Color := clred;
    MoveTo(chart1.Width - 50, 6);
    LineTo(chart1.Width - 32, 6);
    Pen.Color := clblue;
    if NonComplex.Checked = false then begin
      MoveTo(chart1.Width - 50, 18);
      LineTo(chart1.Width - 32, 18);
    end;
  end;
end;

// vZ
// x̒l傫Ȃƌ덷傫Ȃ܂B
procedure TForm1.Button1Click(Sender: TObject);
label
  EXT;
const
  N = 200;
  x0m = 1e-50;        // [ߖTl infinty ̕ݒvZl
  zeromg = '1E-90';   // vZʕ\菬l0ɂ܂ Z1/2
var
  ch, i : integer;
  berxe, beixe: double;
  xin, vin, xv, rk, ik: double;
  xmin, xmax, dx : double;
  ymin, ymax, yre, yim : double;
  xm, vm, xvm, ixm: mp_float;
  nd, tmf : mp_float;
  ri : mp_complex;
  xc, xcb : mp_complex;
  k : integer;
  vk, avm, tmf0, zz : mp_float;

  redata : DArray;
  imdata : DArray;

  ix, x : double;
  istr : string;

  // double to mpc  OtvZp
  procedure xvtoXc(xv, ia : double; var xc : mp_complex);
  begin
    mpf_set_dbl(xvm, xv);
    mpf_set_dbl(tmf, ia);
    mpc_set_mpf(xc, xvm, tmf);
  end;

begin
  memo1.Clear;
  val(labelededit1.Text, vin, ch);
  if ch <> 0 then begin
    application.MessageBox('v̒lɊԈႢ܂B','', 0);
    exit;
  end;
  if abs(vin) > Vmax then begin
    application.MessageBox('v̒lvZ͈͊OłB','', 0);
    exit;
  end;
  val(labelededit2.Text, xin, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','', 0);
    exit;
  end;
  if abs(xin) > 100 then begin
    application.MessageBox('x100zƏɂČ덷傫Ȃ܂B','', 0);
  end;
  if NonComplex.Checked = false then begin
    val(labelededit3.Text, ix, ch);
    if ch <> 0 then begin
      application.MessageBox('i ̒lɊԈႢ܂B','', 0);
      exit;
    end;
    if abs(ix) > 100 then begin
      application.MessageBox('i100zƏɂČ덷傫Ȃ܂B','', 0);
    end;
  end
  else ix := 0;

  mpf_init4(xm, vm, xvm, ixm);
  mpf_init3(nd, tmf, zz);
  mpf_init3(vk, avm, tmf0);
  mpc_init3(ri, xc, xcb);

  mpf_set0(zero);
  mpf_set0(ixm);

  mpf_read_decimal(vm, PAnsiChar(ansistring(labelededit1.Text + #00)));
  mpf_read_decimal(xm, PAnsiChar(ansistring(labelededit2.Text + #00)));
  if NonComplex.Checked = false then
    mpf_read_decimal(ixm, PAnsiChar(ansistring(labelededit3.Text + #00)));

  mpf_read_decimal(zz, PAnsiChar(ansistring(zeromg + #00)));

  setlength(redata, N + 1);
  setlength(imdata, N + 1);

  mpc_set_mpf(xcb, xm, ixm);                   // xcb vZp x̕f

  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  series5.Clear;
  series6.Clear;

  ChartBackclear;

  berxe := 0;
  beixe := 0;
  if NonComplex.Checked = false then begin
    if ix >= 0 then istr := ' +' + floatTostr(ix) + 'i'
               else istr := ' ' + floatTostr(ix) + 'i';
    memo1.Lines.Append('v = ' + floatTostr(vin) + '@@x = ' + floatTostr(xin) + istr);
  end
  else
    memo1.Lines.Append('v = ' + floatTostr(vin) + '@@x = ' + floatTostr(xin));

  application.ProcessMessages;

  rk := 0;
  ik := 0;

  // K}lzvZ
  if mpf_is_ge(vm, zero) then begin
    for k := 0 to KMmax do begin
      mpf_set_int(tmf, k);                    // k
      mpf_add(tmf, vm, tmf0);                 // v + k
      mpf_add(tmf0, oneahf, vk);              // vk= v + k + 3/2
      gammaMul(vk, PVG[k]);                   // (n+k+3/2)
    end;
  end
  else begin
    for k := 0 to KMmax do begin
      mpf_set1(nd);
      mpf_set_int(tmf, k);                    // k
      mpf_add(tmf, vm, tmf0);                 // -v + k
      mpf_add(tmf0, oneahf, vk);              // vk= -v + k + 3/2
      if mpf_is_lt(vk, zero) then begin       // vk < 0  nxmF
        mpf_int(vk, tmf);                     // int(vk);
        mpf_sub(vk, tmf, nd);                 // vk - int(vk) vk̐ nd = 0
      end;
      if mpf_is_ne(vk, zero) and mpf_is_ne(nd, zero) then // vk̐̎͌vZȂ
        gammaMul(vk, PVG[k])                  // (n+k+3/2)
      else
        mpf_set0(PVG[k]);                     // (n+k+3/2) = 0
    end;
  end;

  // [ߖŤvZ@啄ݒ
  // x=0 @v < -1   }
  mpf_chs(one, tmf0);                         // -1
  if mpc_is0(xcb) and mpf_is_lt(vm, tmf0) and mpf_is_ne(nd, zero) then begin
    xvtoxc(x0m, ix, xc);                      // x double to mpc
    Hvx(vm, xc, ri);                          // [ߕӂ̃vXxvZ
    if mpf_is_gt(ri.re, zero) then rk := infinity;      // x=0̖}ݒ
    if mpf_is_lt(ri.re, zero) then rk := -infinity;
    if mpf_is_gt(ri.im, zero) then ik := infinity;
    if mpf_is_lt(ri.im, zero) then ik := -infinity;
  end;

  // \ľvZ
  Hvx(vm, xcb, ri);                         // xcb f
  mpf_div(one, two, tmf);                   // 0.5
  mpf_abs(vm, avm);                         // |v|
  mpf_frac(avm, avm);                       // avm - int(avm)
  // v = *.5 x=0 ̎ Hvx Lvx = 0
  if mpc_is0(xcb) and mpf_is_eq(avm, tmf) then begin
    if checkbox3.Checked = false then
      memo1.Lines.Append( string('Hv(x) = ' + mpf_decimal(ri.re, 50)))
    else
      memo1.Lines.Append( string('Lv(x) = ' + mpf_decimal(ri.re, 50)));
    if NonComplex.Checked = false then  begin
      if mpf_is_ge(ri.im, zero) then
        memo1.Lines.Append( string('          +' + mpf_decimal(ri.im, 50) + 'i'))
      else
        memo1.Lines.Append( string('           ' + mpf_decimal(ri.im, 50) + 'i'));
    end;
    berxe := mpf_todouble(ri.re);           // Otpdoublel
    beixe := mpf_todouble(ri.im);
  end
  else
  // x=0 @v < -1 @vk =   ̏ꍇ  }
    if mpc_is0(xcb) and mpf_is_lt(vm, tmf0) and mpf_is_ne(nd, zero) then begin
      berxe := rk;                          // }厞
      beixe := ik;
      if checkbox3.Checked = false then
        memo1.Lines.Append('Hv(x) =  ' + floatTostr(berxe))       // \
      else
        memo1.Lines.Append('Lv(x) =  ' + floatTostr(berxe));      // \
      if NonComplex.Checked = false then
        if beixe >= 0 then
          memo1.Lines.Append('            +' + floatTostr(beixe) + 'i');
    end
    else begin
      if checkbox3.Checked = false then
        memo1.Lines.Append( string('Hv(x) = ' + mpf_decimal(ri.re, 50)))
      else
        memo1.Lines.Append( string('Lv(x) = ' + mpf_decimal(ri.re, 50)));
      if NonComplex.Checked = false then begin
        if mpf_is_ge(ri.im, zero) then
          memo1.Lines.Append( string('          +' + mpf_decimal(ri.im, 50) + 'i'))
        else
          memo1.Lines.Append( string('           ' + mpf_decimal(ri.im, 50) + 'i'));
      end;
      berxe := mpf_todouble(ri.re);         // Otpdoublel
      beixe := mpf_todouble(ri.im);
    end;

  if checkbox2.Checked = true then begin          // OtI
    Chart1.Canvas.Font.Style := [fsBold];
    Chart1.Canvas.Font.size := 8;
    Chart1.Canvas.TextOut(170, 115,'Ot');
    goto EXT;
  end;

  // Ot\
  ymin := 0;
  ymax := 0;
  if checkbox3.Checked = false then begin
    xmin := round(xin) - 10;
    xmax :=  xmin + 20;
    dx := 20 / N;
  end
  else begin
    xmin := round(xin) - 5;
    xmax :=  xmin + 10;
    dx := 10 / N;
  end;

  for i := 0 to N do begin
    x := dx * i + xmin;
    xvtoXc(x, ix, xc);
    if not mpc_is0(xc) then begin
      Hvx(vm, xc, ri);                              // xcb f
      yre := mpf_todouble(ri.re);
      yim := mpf_todouble(ri.im);
      if ymin > yre then ymin := yre;
      if ymax < yre then ymax := yre;
      if ymin > yim then ymin := yim;
      if ymax < yim then ymax := yim;
      redata[i] := yre;
      imdata[i] := yim;

      if x < 0 then begin
        series1.AddXY(x, yre);
        if NonComplex.Checked = false then
          series2.AddXY(x, yim);
      end
      else begin
        series5.AddXY(x, yre);
        if NonComplex.Checked = false then
          series6.AddXY(x, yim);
      end;
    end;
  end;

  for i := 0 to N do begin
    x := dx * i + xmin;
    if x < 0 then begin
      series1.AddXY(x, redata[i]);
      if NonComplex.Checked = false then
        series2.AddXY(x, imdata[i]);
    end;
    if x = 0 then begin
      xv := abs(berxe);
      if xv = infinity then begin
        if berxe < 0 then series5.AddXY(0, ymin - 3)
                     else series5.AddXY(0, ymax + 3);
      end;
    end;
    if x > 0 then begin
      series5.AddXY(x, redata[i]);
      if NonComplex.Checked = false then
        series6.AddXY(x, imdata[i]);
    end;
  end;

  xv := abs(berxe);
  if xv <> infinity then begin
    if NonComplex.Checked = false then
      series4.AddXY(xin, beixe);
    series3.AddXY(xin, berxe);
  end
  else begin
    if berxe < 0 then series3.AddXY(0, ymin - 3)
                 else series3.AddXY(0, ymax + 3);
  end;

  application.ProcessMessages;
  chart1coment;
EXT:
  mpf_clear4(xm, vm, xvm, ixm);
  mpf_clear3(nd, tmf, zz);
  mpc_clear3(ri, xc, xcb);
  mpf_clear3(vk, avm, tmf0);
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
  N, D, tmp : mp_float;
  bt : Tbitmap;
begin
  mpf_set_default_decprec(180);   // L180 50̐xɕKvłB
  setlength(BM, NB + 1);          // xk[Cz
  setlength(FA, KMmax + 1);       // (i+3/2)z
  setlength(PVG, KMmax + 1);      // +v


  for i := 0 to NB do mpf_init(BM[i]);
  for i := 0 to KMmax do mpf_init(FA[i]);
  for i := 0 to KMmax do mpf_init(PVG[i]);


  mpf_init3(N, D, tmp);
  mpf_init4(zero, one, two, four);
  mpf_init3(three, pai, log_2pis2);
  mpf_init(oneahf);

  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);
  mpf_div(three, two, oneahf);    // 3/2

  mpf_mul(pai, two, tmp);         // 2
  mpf_ln(tmp, tmp);               // ln(2)
  mpf_div(tmp, two, log_2pis2);   // ln(2)/2


  Bernoulli_number_BigInteger;    //  xk[C쐬

  for i := 0 to NB do begin
    mpf_read_decimal(N, PAnsiChar(ansistring(NumeratorString[i] + #00)));
    mpf_read_decimal(D, PAnsiChar(ansistring(DenominatorString[i] + #00)));
    mpf_div(N, D, BM[i]);
  end;

  for i := 0 to KMmax do begin    // (i+3/2)z쐬
    mpf_add_int(oneahf, i, tmp);
    gammaMul(tmp, FA[i])
  end;

  memo1.Clear;

  bt := Tbitmap.Create;
  bt.Width := Chart1.Width;
  bt.Height := Chart1.Height;
  Chart1.BackImage.Bitmap := bt;
  bt.Free;

  ChartBackclear;
  if NonComplex.Checked = true then begin
    Labelededit3.Visible := False;
    Labelededit2.Left := 460;
  end;

  mpf_clear3(N, D, tmp);
end;

procedure TForm1.NonComplexClick(Sender: TObject);
begin
  if NonComplex.Checked = true then begin
    Labelededit3.Visible := false;
    Labelededit2.Left := 460;
  end
  else begin
    Labelededit3.Visible := True;
    Labelededit2.Left := 432;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := 0 to NB do mpf_clear(BM[i]);
  for i := 0 to KMmax do mpf_clear(FA[i]);
  for i := 0 to KMmax do mpf_clear(PVG[i]);
  mpf_clear4(zero, one, two, four);
  mpf_clear3(three, pai, log_2pis2);
  mpf_clear(oneahf);
end;

end.
